# coding: utf-8

"""
    FastAPI

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from instalabel.client.models.b_box_annotation import BBoxAnnotation
from instalabel.client.models.polygon_annotation import PolygonAnnotation
from typing import Optional, Set
from typing_extensions import Self

class AnnotationData(BaseModel):
    """
    Represents the structure of annotations as stored in the database.  Attributes:     rectangles (List[BBoxAnnotation]): List of bounding box annotations     polygons (List[PolygonAnnotation]): List of polygon annotations
    """ # noqa: E501
    rectangles: Optional[List[BBoxAnnotation]] = Field(default=None, description="List of bounding box annotations")
    polygons: Optional[List[PolygonAnnotation]] = Field(default=None, description="List of polygon annotations")
    __properties: ClassVar[List[str]] = ["rectangles", "polygons"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AnnotationData from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in rectangles (list)
        _items = []
        if self.rectangles:
            for _item_rectangles in self.rectangles:
                if _item_rectangles:
                    _items.append(_item_rectangles.to_dict())
            _dict['rectangles'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in polygons (list)
        _items = []
        if self.polygons:
            for _item_polygons in self.polygons:
                if _item_polygons:
                    _items.append(_item_polygons.to_dict())
            _dict['polygons'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AnnotationData from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "rectangles": [BBoxAnnotation.from_dict(_item) for _item in obj["rectangles"]] if obj.get("rectangles") is not None else None,
            "polygons": [PolygonAnnotation.from_dict(_item) for _item in obj["polygons"]] if obj.get("polygons") is not None else None
        })
        return _obj


