# coding: utf-8

"""
    FastAPI

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from instalabel.client.models.workspace_credits import WorkspaceCredits
from typing import Optional, Set
from typing_extensions import Self

class WorkspaceInDB(BaseModel):
    """
    WorkspaceInDB
    """ # noqa: E501
    workspace_id: Optional[StrictStr] = Field(default=None, description="Unique identifier for the workspace", alias="workspaceId")
    workspace_name: StrictStr = Field(description="Name of the workspace", alias="workspaceName")
    owner_id: StrictStr = Field(description="Unique identifier for the owner of the workspace", alias="ownerId")
    description: Optional[StrictStr] = None
    created_at: Optional[StrictStr] = Field(default=None, description="Timestamp when the workspace was created, including timezone info", alias="createdAt")
    updated_at: Optional[StrictStr] = Field(default=None, description="Timestamp when the workspace was last updated, including timezone info", alias="updatedAt")
    product_id: Optional[StrictStr] = Field(default=None, alias="productId")
    credits: WorkspaceCredits = Field(description="Credit limits and usage tracking for the workspace")
    __properties: ClassVar[List[str]] = ["workspaceId", "workspaceName", "ownerId", "description", "createdAt", "updatedAt", "productId", "credits"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of WorkspaceInDB from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of credits
        if self.credits:
            _dict['credits'] = self.credits.to_dict()
        # set to None if description (nullable) is None
        # and model_fields_set contains the field
        if self.description is None and "description" in self.model_fields_set:
            _dict['description'] = None

        # set to None if product_id (nullable) is None
        # and model_fields_set contains the field
        if self.product_id is None and "product_id" in self.model_fields_set:
            _dict['productId'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of WorkspaceInDB from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "workspaceId": obj.get("workspaceId"),
            "workspaceName": obj.get("workspaceName"),
            "ownerId": obj.get("ownerId"),
            "description": obj.get("description"),
            "createdAt": obj.get("createdAt"),
            "updatedAt": obj.get("updatedAt"),
            "productId": obj.get("productId"),
            "credits": WorkspaceCredits.from_dict(obj["credits"]) if obj.get("credits") is not None else None
        })
        return _obj


